require 'httparty'
require 'json'
require 'rest-client'
#require 'resolv-replace'

module ApioticsFactory
  class Portal
    
    def self.driver(driver)
      puts "portal: #{ApioticsFactory.configuration.portal}"
      puts "public_key: #{ApioticsFactory.configuration.public_key}"
      puts "private_key: #{ApioticsFactory.configuration.private_key}"
      puts "id: #{driver}"
      json = HTTParty.post("#{ApioticsFactory.configuration.portal}api/driver", :query => {:public_key => ApioticsFactory.configuration.public_key, :private_key => ApioticsFactory.configuration.private_key, driver: driver}).body
    end
    
    def self.driver_version(driver)
      json = HTTParty.post("#{ApioticsFactory.configuration.portal}api/driver_version", :query => {:public_key => ApioticsFactory.configuration.public_key, :private_key => ApioticsFactory.configuration.private_key, driver: driver}).body
    end
    
    def self.publish_driver(driver, path)
      payload = {
        :multipart => true,
        :file => File.open(path, 'rb'),
        :public_key => ApioticsFactory.configuration.public_key,
        :private_key => ApioticsFactory.configuration.private_key,
        :driver => driver
      }
      r = RestClient.post("#{ApioticsFactory.configuration.portal}api/upload_driver", payload)
    end
    
  end
end